Index: core/kernel/processors/main_processor.php
===================================================================
--- core/kernel/processors/main_processor.php	(revision 13284)
+++ core/kernel/processors/main_processor.php	(working copy)
@@ -706,6 +706,37 @@
 		$perm_helper =& $this->Application->recallObject('PermissionsHelper');
 		return $perm_helper->TagPermissionCheck($params);
 	}
+	
+	/**
+	 * Redirects to a new template or external url accepting the same parameters as m_Link tag
+	 *
+	 * @param Array $params
+	 */
+	function Redirect($params)
+	{
+		$location = $this->Link($params);
+		
+		if (!$location) {
+			return;
+		}
+		
+		if ($this->Application->isDebugMode() && constOn('DBG_REDIRECT')) {
+			$this->Application->Debugger->appendTrace();
+			echo "<b>Debug output above!!!</b> Proceed to redirect: <a href=\"$location\">$location</a><br>";			
+		}
+		else {		
+			header('Location: ' . $location);				
+			
+			ob_end_flush();			
+			
+			$session =& $this->Application->recallObject('Session');
+			/* @var $session Session */
+	
+			$this->Application->HandleEvent( new kEvent('adm:OnBeforeShutdown') );
+			$session->SaveData();			
+		}		
+		exit;
+	}
 
 	/**
 	 * Checks if user is logged in and if not redirects it to template passed
@@ -791,6 +822,8 @@
 			$this->Application->Redirect($params['login_template'], $redirect_params);
 		}
 	}
+	
+	
 
 	function IsMember($params)
 	{
